import java.util.LinkedList;

public abstract class EtatAlerte {

	protected LinkedList<TransfertPublie> historique;

	public abstract EtatAlerte signalerUnTransfert( TransfertPublie t );

	public EtatAlerte(){
		this.historique = new LinkedList<TransfertPublie>();
	}
	public EtatAlerte( LinkedList<TransfertPublie> historique ){
		this.historique = historique;
	}

	protected void ajouterTransfertHistorique( TransfertPublie transfert ){
		this.historique.add( transfert );
	}

	public TransfertPublie getLastTransfert(){
		return this.historique.getLast();
	}
	
	protected EtatAlerte getEtatAlerte(){
		EtatAlerte result;
		if( this.getLastTransfert().getNouveauSolde() >= 200 ){
			result = new EtatAlerteNormale( this.historique );
		}else if( this.getLastTransfert().getNouveauSolde() >= 0 ){
			result = new EtatAlerteMoyenne( this.historique );
		}else{
			result = new EtatAlerteHaute( this.historique );
		}
		return result;
	}
	
	public LinkedList<TransfertPublie> getHistorique(){
		return this.historique;
	}

}
