import java.awt.BorderLayout;
import javax.swing.JFrame;
import javax.swing.BoxLayout;
import javax.swing.JButton;
import javax.swing.JPanel;
import javax.swing.JTextField;
import javax.swing.JLabel;
import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;
import java.util.Observer;
import java.util.Observable;

public class compteVue extends Observable implements Vue, ActionListener {

	private JTextField champs_transfert;
	private JLabel zone_texte;
	private JButton bouton_transfert;
	private JLabel solde;

	private JFrame fenetre;
	
	private void notify(Object obj) {
		this.setChanged();
		this.notifyObservers(obj);
	}

	@Override
	public void actionPerformed(ActionEvent arg0) {
		try {
			Transfert transfert = new Transfert(this.obtenir_valeur_transfert());
			this.notify(transfert);
		} catch (Exception e) {
			System.out.println( e );
			e.printStackTrace();
			this.display_message("Le champs n'est pas un entier !");
		}
	}

	public compteVue() {
		fenetre = new JFrame("Transfert");
		fenetre.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);

		solde = new JLabel("");

		champs_transfert = new JTextField();
		champs_transfert.setColumns(5);

		bouton_transfert = new JButton("Realiser le transfert");
		bouton_transfert.addActionListener(this);

		zone_texte = new JLabel("Rien a signaler");

		JPanel panneau = new JPanel();
		panneau.setLayout(new BoxLayout(panneau, BoxLayout.Y_AXIS));
		panneau.add(new JLabel("Solde :"));
		panneau.add(solde);
		panneau.add(new JLabel("Argent a transferer :"));
		panneau.add(champs_transfert);
		panneau.add(bouton_transfert);
		panneau.add(zone_texte);

		fenetre.getContentPane().add(panneau, BorderLayout.CENTER);

		fenetre.setVisible(true);
		fenetre.pack();
	}

	public void change_solde(int solde) {
		this.solde.setText((new Integer(solde)).toString());
		this.updateGUI();
	}
	
	private void updateGUI(){
		this.zone_texte.updateUI();
		this.solde.updateUI();
		this.fenetre.pack();
	}
	public void display_message(String message) {
		this.zone_texte.setText(message);
		this.updateGUI();
	}

	public void attendre_une_demande_de_transfert(Observer observeur) {
		this.addObserver(observeur);
	}

	public int obtenir_valeur_transfert() {
		return (Integer.decode(this.champs_transfert.getText())).intValue();
	}

}
